<?
	####################################
	# pftp 1.0 - ftp over the web      #
	# Copyright 2001 Antonio Bonifati, #
	# distributed under GPL            #
	# http://queen.rett.polimi.it/~ant  #
	####################################

# configuration

	# autentication: a basic sample .htaccess is provided in this directory

	# limit the maximum execution time
	# must be enough to allow successfully uploads/downloads from slow connections
	# if is set to zero, no time limit is imposed
	set_time_limit(0);

	# pftp features zip, tar, gzip, bzip2, tar+gzip, tar+bzip2 auto-expansion
	# for this to work it needs that
	#
	# UnZip (http://www.info-zip.org/pub/infozip/),
	# GNU tar (http://www.gnu.org/software/tar/)
	# Gzip (http://www.gnu.org/software/gzip/)
	# Bzip2 (http://sourceware.cygnus.com/bzip2/)
	#
	# are installed on the server and can be reached to the following paths.
	# since all these compression programs are freely available i recommend that you install them
	# please do not try to use other tar than GNU tar: it probably won't work
	# for example if GNU tar is installed in /usr/local/bin/
	# use define('TARPATH', '/usr/local/bin/tar');
	define('UNZIPPATH', 'unzip');
	define('TARPATH', 'tar');
	define('GUNZIPPATH', 'gunzip');
	define('BUNZIP2PATH', 'bunzip2');

	# note that the user under which the web server runs
	# (usually nobody or apache) must have write and
	# execute permission (wx) in a directory where you
	# want to allow file uploads. read permission (r)
	# on a directory is the only required to be able
	# to list the files on it, but if you want to be
	# able to download a file you must also set the
	# execute permission (x) on the directory that contains it.

	# alphabetically sort output
	define('OUTSORT', TRUE);

	# max entry length (255 with ext2 fs)
	define('MAXEL', 255);

	# redefine umask for creating directories
	# (no effect with uncompressed directories)
	umask(022);

	# mode for creating new directories (use a leading zero for octal numbers)
	# directory permission will be DMODE & ~umask
	# so don't forget to set the appropriate umask also
	# (no effect with uncompressed directories)
	define('DMODE', 0755);

	# define permissions for uploaded file
	# (no effect with uncompressed files)
	define('FMODE', 0644);

	# to list directories first and then files use
	#	entrylist('D');
	#	entrylist('F');
	# to list files first and then directories use
	#	entrylist('F');
	#	entrylist('D');

	# print sizes in human readable format (e.g., 1k 234M 2G) (TRUE)
	# or in bytes (FALSE)
	define('READABLESIZE', TRUE);

	# set locale language for date (e.g. en_EN, it_IT, ...)
	setlocale (LC_TIME, 'en_EN');

	# file modification date and time format (see php-manual-*/function.strftime.html)
	# e.g. with '%d-%b-%Y %R': 01-May-2001 16:53
	define('TIMEFMT', '%d-%b-%Y %R');

	# display directories size (usually a cluster size)
	define('DIRSIZE', FALSE);

	# start directory; user can't get out of this directory (omit / at the end)
	define('HOME', '/home/'.$PHP_AUTH_USER.'/public_html');

	# how HOME is mapped via www (don't include / at the end)
	define('WWWHOME', '/~'.$PHP_AUTH_USER);

	# file and directory output format (simply omit %entry_size% if you don't want that information, etc.)
	# note that %href_entry_url% (or %href_entry_down%) will be substituted with
	#	[space]href="%entry_url%"
	# only if you have permission to access that entry,
	# i.e. download a file (r permission) or change to/list a directory (x permission e/o r permission)
	# otherwise %href_entry_url% will be stripped so that remains no link:
	# (i.e. <a>...</a>)
	define('OUTFFMT', "<tr><td>[ <a%href_entry_url% target=\"_new\">V</a> ] [ <a%href_entry_del%>D</a> ]</td><td><a%href_entry_down%>%entry_name%</a></td><td>%entry_time%</td><td>%entry_size%</td></tr>\n");
	define('OUTDFMT', "<tr><td>[ <a%href_entry_del% onClick='return confirm(\"cancellare la directory %entry_name% e tutti i file e directory in essa contenuti ?\")'>D</a> ]</td><td><a%href_entry_url%>%entry_name%/</a></td><td>%entry_time%</td><td>%entry_size%</td></tr>\n");

	# the maximum filesize accepted (in bytes).
	# you  cannot specify a file size greater than the file size
	# that has been set in the upload_max_filesize in the php.ini file
	# The default is 2097152 (2 Meg)
	define('MAXFILESIZE', 2097152);

	# quota in bytes. Default is 2097152 (2 Meg)
	# warning: quota can be exceeded if the user uses auto-uncompress with well-compressible files
	# but only one time
	define('QUOTA', 2097152);

	# here you can customize state and error messages

	# initial value of $log variable
	$log = 'Some operation results will be printed here';

	# string printed instead of mime type when that is unknown
	$mimeunknown='mime type unknown';

	$errmsg=array(
	   'Error: quota exceeded.',
	   'Error uncompressing zip file "%s".',
	   'Error uncompressing gzip file "%s".',
	   'Error uncompressing bzip2 file "%s".',
	   'Error extracting tar file "%s".',
	   'Error uncompressing file "%s". Format unknown.',
	   'Error uploading file "%s". Probably a permission problem.',
	   'Error uploading file "%s". Does this file exist?',
	   'Error deleting file "%s".',
	   'Error creating directory "%s". Probably it exists already.',
	   'Error deleting directory "%s".',
	   'Error reading directory "%s/"'
	);

	$statemsg=array(
	   'Zip file "%s" (%s) successfully uncompressed.',
	   'Gzipped file "%s" (%s) successfully uncompressed.',
	   'Gzipped and tarred file "%s" (%s) successfully uncompressed.',
	   'Bzipped file "%s" (%s) successfully uncompressed.',
	   'Bzipped and tarred file "%s" (%s) successfully uncompressed.',
	   'Tar file "%s" (%s) successfully extracted.',
	   'File "%s" (%s, %s) uploaded.',
	   'File "%s" deleted.',
	   'Directory "%s" created.',
	   'Directory "%s" deleted.'
	);
?>
