<?
	####################################
	# pftp 1.0 - ftp over the web      #
	# Copyright 2001 Antonio Bonifati, #
	# distributed under GPL            #
	# http://queen.rett.polimi.it/~ant  #
	####################################

# read configuration
	require('conf.php');

# include utility function
	require('util.php');

### main

# disable caching on the client side
	noCacheHeaders();

# set the current path on server ($realpath)
	# strip ../ and .. from $cd, $m and $dd for security reasons
	stripPointPoint($cd);
	stripPointPoint($m);
	stripPointPoint($dd);
	$realdir=HOME.$cd.'/';

# this boolean variable is TRUE if you have permission to
# upload files (or delete file and directories) in the current dir, FALSE otherwise
# (see index.html for hint how it can be used)
	$wxperm=is_writable($realdir) && is_executable_fd($realdir);

# handle file upload

	if (is_uploaded_file($upfile))
	{
	   # set the usedspace in order to verify the quote
	   $usedspace=(int)exec('du -sk '.HOME)*1024;

	   if ($usedspace + $upfile_size - (
	         file_exists($realdir.$upfile_name) ? filesize($realdir.$upfile_name) : 0
	       ) > QUOTA)
	      # Error: quota exceeded.
	      $log = $errmsg[0];
	   else if ($au=='on')
	   {
	      # auto uncompress
	      # compression format supported: tar, gzip, tar+gzip, zip

	      # find mime type of uploaded file
	      # if the browser provided that information, trust it
	      # only if extension tests fail.

	      # use file extension to guess mime type
	      $lufn=strtolower($upfile_name);
	      $ext3=substr($lufn, strlen($upfile_name)-3);
	      $ext4=substr($lufn, strlen($upfile_name)-4);
	      $ext7=substr($lufn, strlen($upfile_name)-7);

	      switch($ext3)
	      {
	         case '.gz':
	            $upfile_type='application/x-gzip';
	            break;
	      }

	      switch($ext4)
	      {
	         case '.tar':
	            $upfile_type='application/x-gtar';
	            break;

	         case '.tgz':
	            $upfile_type='application/x-gzip';
	            break;

	         case '.zip':
	            $upfile_type='application/zip';
	            break;

	         case '.bz2':
	            $upfile_type='application/x-bzip2';
	      }

	      switch(ext7)
	      {
	         case '.tar.gz':
	            $upfile_type='application/x-gzip';
	            break;
	      }

	      switch($upfile_type)
	      {
	         case 'application/zip':
	         case 'application/x-zip-compressed':
	            system(UNZIPPATH." -o -qq $upfile -d ". EscapeShellArg($realdir), $ret);
	            if ($ret)
	               # Error uncompressing zip file "%s".
	               $log = sprintf($errmsg[1], $upfile_name);
	            else
	               # Zip file "%s" (%s) successfully uncompressed.
	               $log = sprintf($statemsg[0], $upfile_name, readablesize($upfile_size));
	            break;

	         case 'application/x-gzip':
	            # it could be a .tar.gz or simply a .gz

	            # try to uncompress as a .tar.gz first
	            system(TARPATH." -zxf $upfile -C ". EscapeShellArg($realdir), $ret);
	            if ($ret)
	            {
	               # there was an error, try to uncompress the file as a .gz
	               system(GUNZIPPATH." -Nc $upfile >". EscapeShellArg($realdir.dropGzExt($upfile_name)), $ret);
	               if ($ret)
	                  # Error uncompressing gzip file "%s".
	                  $log = sprintf($errmsg[2], $upfile_name);
	               else
	                  # Gzipped file "%s" (%s) successfully uncompressed.
	                  $log = sprintf($statemsg[1], $upfile_name, readablesize($upfile_size));
	            }
	            else
	               # Gzipped and tarred file "%s" (%s) successfully uncompressed.
	               $log = sprintf($statemsg[2], $upfile_name, readablesize($upfile_size));
	            break;

	         case 'application/x-bzip2':
	            # it could be a .tar.bz2 or simply a .bz2

	            # try to uncompress as a .tar.bz2 first
	            system(TARPATH." -jxf $upfile -C ". EscapeShellArg($realdir), $ret);
	            if ($ret)
	            {
	               # there was an error, try to uncompress the file as a .bz2
	               system(BUNZIP2PATH." -c $upfile >". EscapeShellArg($realdir.dropBz2Ext($upfile_name)), $ret);
	               if ($ret)
	                  # Error uncompressing bzip2 file "%s".
	                  $log = sprintf($errmsg[3], $upfile_name);
	               else
	                  # Bzipped file "%s" (%s) successfully uncompressed.
	                  $log = sprintf($statemsg[3], $upfile_name, readablesize($upfile_size));
	            }
	            else
	               # Bzipped and tarred file "%s" (%s) successfully uncompressed.
	               $log = sprintf($statemsg[4], $upfile_name, readablesize($upfile_size));
	            break;

	         case 'application/x-gtar':
	         case 'application/x-tar':
	            system(TARPATH.' -xf '. EscapeShellArg($upfile) .' -C '. EscapeShellArg($realdir), $ret);
	            if ($ret)
	               # Error extracting tar file "%s".
	               $log = sprintf($errmsg[4], $upfile_name);
	            else
	               # Tar file "%s" (%s) successfully extracted.
	               $log = sprintf($statemsg[5], $upfile_name, readablesize($upfile_size));
	            break;

	         default:
	            # Error uncompressing file "%s". Format unknown.
	            $log = sprintf($errmsg[5], $upfile_name);
	      }
	   }
	   else if (!@move_uploaded_file($upfile, $realdir.$upfile_name))
	      # Error uploading file "%s". Probably a permission problem.
	      $log = sprintf($errmsg[6], $upfile_name);
	   else
	   {
	      chmod($realdir.$upfile_name, FMODE);

	      if ($upfile_type=='') $upfile_type=$mimeunknown;

	      # File "%s" (%s, %s) uploaded.
	      $log = sprintf($statemsg[6], $upfile_name, readablesize($upfile_size), $upfile_type);
	   }
	}
	else if ($upfile=='none')
	   # if $upfile=='none' file doesn't exist on the remote client
	   # but the browser has sent the form anyway
	   # Error uploading file "%s". Does this file exist?
	   $log = sprintf($errmsg[7], $upfile_name);

# handle file deletion
	if ($wxperm && isset($d))
	   if (!@unlink($realdir.$d))
	      # Error deleting file "%s".
	      $log = sprintf($errmsg[8], $d);
	   else
	      # File "%s" deleted.
	      $log = sprintf($statemsg[7], $d);

# handle mkdir
	if ($m!='')
	   if (!@mkdir($realdir.$m, DMODE))
	      # Error creating directory "%s". Probably it exists already.
	      $log = sprintf($errmsg[9], $m);
	   else
	      # Directory "%s" created.
	      $log = sprintf($statemsg[8], $m);

# handle rm -r directory
	if ($dd!='')
	{
	   system('rm -r '. escapeshellarg($realdir.$dd), $ret);
	   if ($ret)
	      # Error deleting directory "%s".
	      $log = sprintf($errmsg[10], $dd);
	   else
	      # Directory "%s" deleted.
	      $log = sprintf($statemsg[9], $dd);
	}

# set the usedspace
	$usedspace=(int)exec('du -sk '.HOME)*1024;

# read directory in array $dir, $file

	settype($dir, 'array');
	settype($file, 'array');
	$handle=@opendir($realdir);
	if (!$handle)
	{
	   if (!$wxperm)
	      # Error reading directory "%s/"
              $log = sprintf($errmsg[11], WWWHOME.$cd);
	   if ($cd!='')
	      $dir[] = '..';
	}
	else
	{
	   while (($entry = readdir($handle)) !== FALSE)
	   {
	      if ($entry=='.' || $entry=='..' && $cd=='')
	         continue;

	      if (is_dir($realdir.$entry) || $entry=='..')
	      {
	         $dir[] = $entry;
	         continue;
	      }
	      $file[] = $entry;
	   }
	   closedir($handle);

	   # sort if required
	   if (OUTSORT)
	   {
	      sort($file);
	      sort($dir);
	   }
	}

### end main

# t (type) is 'D' for directories, 'F' for files
function entrylist($t)
{
   global $realdir, $cd, $file, $dir, $wxperm;

   if ($t=='F')
      $a =& $file;
   else
      $a =& $dir;

   while (list(, $entry)=each($a))
   {
      if ($t=='F')
      {
         if (is_readable($realdir.$entry))
         {
            $out=str_replace('%href_entry_url%', ' href="'. WWWHOME.pathencode($cd).'/'.urlencode($entry) .'"', OUTFFMT);
            $out=str_replace('%href_entry_down%', ' href="download.php?p='. urlencode($cd.'/'.$entry) .'"', $out);
            if ($wxperm)
               $out=str_replace('%href_entry_del%', ' href="?cd='. urlencode($cd) .'&d='. urlencode($entry) .'"', $out);
         }
         else
            $out=str_replace('%href_entry_url%', '', OUTFFMT);
      }
      else // $t=='D'
      {
         $out=OUTDFMT;
         if ($entry=='..' || is_readable($realdir.$entry)
               || is_writable($realdir.$entry) && is_executable_fd($realdir.$entry))
            $out=str_replace('%href_entry_url%', ' href="?cd='.
               urlencode($entry=='..' ? dropLastEntry($cd) : $cd.'/'.$entry).  '"', $out);
         if ($wxperm && $entry!='..')
            $out=str_replace('%href_entry_del%', ' href="?cd='. urlencode($cd) .'&dd='. urlencode($entry) .'"', $out);
      }

      $out=str_replace('%entry_name%', $entry, $out);
      $filemtime=filemtime($realdir.$entry);
      $out=str_replace('%entry_time%', ($filemtime!==false ? strftime(TIMEFMT, $filemtime) : '&nbsp;'), $out);
      $filesize=filesize($realdir.$entry);
      $out=str_replace('%entry_size%',
         ($t=='F' || DIRSIZE) && $filesize!==false ?
            (READABLESIZE ? readablesize($filesize) : $filesize)
         : '&nbsp',
         $out);

      echo $out;
   }
}

?>
