<?
	####################################
	# pftp 1.0 - ftp over the web      #
	# Copyright 2001 Antonio Bonifati, #
	# distributed under GPL            #
	# http://queen.rett.polimi.it/~ant  #
	####################################

# utility functions

function readablesize($size)
{
   # powers of 1024 are used
   # you can also use sprintf
   # e.g.:	return sprintf('%.1fk', $size/1024);
   # is the same as: return round($size/1024, 1).'k';

   if ($size<1024)                      # <1k
      return $size.'b';
   if ($size<10240)                     # <10k
      return round($size/1024, 1).'k';
   if ($size<1048576)                   # <1M
      return round($size/1024).'k';
   if ($size<1073741824)                # < 1G
      return round($size/1048576).'M';
   return round($size/1073741824).'G';  # > 1G
}

# drops last entry from a directory or file path
function dropLastEntry($path)
{
   $lastchar=strlen($path)-1;
   if ($path[$lastchar]=='/')
      $path=substr($path, 0, $lastchar);
   if (($lastslash=strrpos($path, '/'))==false)
      return '';
   else
      return substr($path, 0, $lastslash);
}

# drops the last extension from a file name if it is .gz
function dropGzExt($path)
{
   $path=strtolower($path);
   $p=strlen($path)-3; # position of . in '.gz'
   if (substr($path, $p)=='.gz')
      return substr($path, 0, $p);
   else
      return $path;
}

# drops the last extension from a file name if it is .bz2
function dropBz2Ext($path)
{
   $path=strtolower($path);
   $p=strlen($path)-4; # position of . in '.bz2'
   if (substr($path, $p)=='.bz2')
      return substr($path, 0, $p);
   else
      return $path;
}

function pathencode($path)
{
   $comp=explode('/', $path);
   for ($i=0; $i<count($comp); $i++)
     $comp[$i]=rawurlencode($comp[$i]);
   return implode('/', $comp);
}

function stripPointPoint(&$path)
{
   $path=str_replace('../', '', $path);
   $path=str_replace('..', '', $path);
   return $path;
}

# send HTTP header to disable caching
function noCacheHeaders()
{
   header ("Expires: Mon, 26 Jul 1997 05:00:00 GMT");    // Date in the past
   header ("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); 
                                                         // always modified
   header ("Cache-Control: no-cache, must-revalidate");  // HTTP/1.1
   header ("Pragma: no-cache");                          // HTTP/1.0
}

# php built in function is_executable doesn't
# work on directories, only on files. This function does:
function is_executable_fd($entryname)
{
   $stat=stat($entryname);
   $myuid=posix_getuid();
   return
      $myuid==$stat[4] && ($stat[2] & 0100)     # owner with executable permission
              ||
      $myuid==$stat[5] && ($stat[2] & 0010)     # in the group with executable permission
              ||
      ($stat[2] & 0001);                        # other with executable permission
}

?>
